﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Web;
using Radzen;
using Radzen.Blazor;
using NorthwindBlazor.Models.Northwind;
using Microsoft.EntityFrameworkCore;

namespace NorthwindBlazor.Pages
{
    public partial class TestComponent : ComponentBase
    {
        [Parameter(CaptureUnmatchedValues = true)]
        public IReadOnlyDictionary<string, dynamic> Attributes { get; set; }

        public void Reload()
        {
            InvokeAsync(StateHasChanged);
        }

        public void OnPropertyChanged(PropertyChangedEventArgs args)
        {
        }

        [Inject]
        protected IJSRuntime JSRuntime { get; set; }

        [Inject]
        protected NavigationManager UriHelper { get; set; }

        [Inject]
        protected DialogService DialogService { get; set; }

        [Inject]
        protected TooltipService TooltipService { get; set; }

        [Inject]
        protected ContextMenuService ContextMenuService { get; set; }

        [Inject]
        protected NotificationService NotificationService { get; set; }

        [Inject]
        protected NorthwindService Northwind { get; set; }

        IEnumerable<NorthwindBlazor.Models.Northwind.Category> _getCategoriesResult;
        protected IEnumerable<NorthwindBlazor.Models.Northwind.Category> getCategoriesResult
        {
            get
            {
                return _getCategoriesResult;
            }
            set
            {
                if (!object.Equals(_getCategoriesResult, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "getCategoriesResult", NewValue = value, OldValue = _getCategoriesResult };
                    _getCategoriesResult = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        IEnumerable<NorthwindBlazor.Models.Northwind.Product> _getProductsResult;
        protected IEnumerable<NorthwindBlazor.Models.Northwind.Product> getProductsResult
        {
            get
            {
                return _getProductsResult;
            }
            set
            {
                if (!object.Equals(_getProductsResult, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "getProductsResult", NewValue = value, OldValue = _getProductsResult };
                    _getProductsResult = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        int _CatID;
        protected int CatID
        {
            get
            {
                return _CatID;
            }
            set
            {
                if (!object.Equals(_CatID, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "CatID", NewValue = value, OldValue = _CatID };
                    _CatID = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        int _ProductID;
        protected int ProductID
        {
            get
            {
                return _ProductID;
            }
            set
            {
                if (!object.Equals(_ProductID, value))
                {
                    var args = new PropertyChangedEventArgs(){ Name = "ProductID", NewValue = value, OldValue = _ProductID };
                    _ProductID = value;
                    OnPropertyChanged(args);
                    Reload();
                }
            }
        }

        protected override async System.Threading.Tasks.Task OnInitializedAsync()
        {
            await Load();
        }
        protected async System.Threading.Tasks.Task Load()
        {
            var northwindGetCategoriesResult = await Northwind.GetCategories();
            getCategoriesResult = northwindGetCategoriesResult;

            var northwindGetProductsResult = await Northwind.GetProducts(new Query() { Filter = $@"i => i.CategoryID == @0", FilterParameters = new object[] { 0 } });
            getProductsResult = northwindGetProductsResult;

            CatID = 0;

            ProductID = 0;
        }

        protected async System.Threading.Tasks.Task Dropdown0Change(dynamic args)
        {
            var northwindGetProductsResult = await Northwind.GetProducts(new Query() { Filter = $@"i => i.CategoryID == @0", FilterParameters = new object[] { CatID } });
            getProductsResult = northwindGetProductsResult;
        }
    }
}
